/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demo.ui;

import demo.business.BasketBean;
import demo.business.BasketLocal;
import demo.business.ShopBean;
import demo.model.Product;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author rosmord
 */
@WebServlet(name = "order", urlPatterns = {"/order"})
public class OrderServlet extends HttpServlet {

    @EJB
    ShopBean shopBean;

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        setData(req);
        req.getRequestDispatcher("/WEB-INF/jsp/order.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        setData(req);
        long id= Long.parseLong(req.getParameter("id"));
        Product p= shopBean.getProduct(id);
        getBasketBean(req).addProduct(p);
        req.getRequestDispatcher("/WEB-INF/jsp/order.jsp").forward(req, resp);
    }

    private void setData(HttpServletRequest req) {
        req.setAttribute("products", shopBean.getAllProducts());        
    }

    private BasketLocal getBasketBean(HttpServletRequest request) {
        HttpSession session = request.getSession();
        if (session.getAttribute("basket") == null) {
            try {
                Context c = new InitialContext();
                BasketLocal b= (BasketLocal) 
                        c.lookup("java:global/DemoBean/BasketBean!demo.business.BasketLocal");
                session.setAttribute("basket", b);
            } catch (NamingException ne) {
                Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
                throw new RuntimeException(ne);
            }
        }
        
        return (BasketLocal) session.getAttribute("basket");
    }

}
